// Swarm library. Copyright (C) 1996 Santa Fe Institute.
// This library is distributed without any warranty; without even the
// implied warranty of merchantability or fitness for a particular purpose.
// See file LICENSE for details and terms of copying.


#import "DiscreteToroid.h"

@implementation DiscreteToroid

-getObjectAtX: (int) inX Y: (int) inY {
  inX = [self wrapXCoord: inX];
  inY = [self wrapYCoord: inY];
  return [super getObjectAtX: inX Y: inY];
}

-putObject: (id) anObject atX: (int) inX Y: (int) inY {
  inX = [self wrapXCoord: inX];
  inY = [self wrapYCoord: inY];
  return [super putObject: anObject atX: inX Y: inY];
}

-(long)getValueAtX: (int) inX Y: (int) inY {
  inX = [self wrapXCoord: inX];
  inY = [self wrapYCoord: inY];
  return [super getValueAtX: inX Y: inY];
}

-putValue: (long) v atX: (int) inX Y: (int) inY {
  inX = [self wrapXCoord: inX];
  inY = [self wrapYCoord: inY];
  return [super putValue: v atX: inX Y: inY];
}



-(int) wrapCoord: (int) inCoord atModulus: (int) inModulus
{
  while ((inCoord) < 0) inCoord += inModulus;
  return (inCoord % inModulus);
}

-(int) wrapXCoord: (int) inCoord
{
  return [self wrapCoord: inCoord atModulus: xsize];
}

-(int) wrapYCoord: (int) inCoord
{
  return [self wrapCoord: inCoord atModulus: ysize];
}


@end
