// ObserverSwarm.h

#import <objectbase.h>
#import <activity.h>
#import <collections.h>
#import <simtools.h>
#import <simtoolsgui.h>               // GUI objects require these includes
#import <simtoolsgui/GUISwarm.h>
#import <analysis.h>                  // graph objects are pre-declared here
#import "ModelSwarm.h"

@interface ObserverSwarm : GUISwarm {
  int displayFrequency;               // one parameter: update freq

  id displayActions;                  // schedule data structs
  id displaySchedule;

  id modelSwarm;

  id <EZGraph> numGraph;              // graph object
  id <EZGraph> payoffGraph;

  id <Colormap> colorMap;             // allocate colours

}

// Methods overriden to make the Swarm.

+createBegin: (id) aZone;
-createEnd;
-buildObjects;
-buildActions;
-activateIn: (id) swarmContext;

@end

