// Tournament.m				     

#import "ModelSwarm.h"
#import <simtools.h>

int matrix[2][2]={{1,5},{0,3}};

@implementation Tournament

+createBegin: (id)  aZone {
  Tournament * obj;

  obj = [super createBegin: aZone];
  return obj;
}

-createEnd {
  return [super createEnd];

}

-setPlayer1: p1  Player2: p2 {
  player1 = p1;
  player2 = p2;
  [player1 setOtherPlayer: player2];
  [player2 setOtherPlayer: player1];
  return self;
}

-updateMemories {
  [player1 remember];
  [player2 remember];
  return self;
}

-distrPayoffs {
  int action1, action2;
  action1 = [player1 getNewAction];
  action2 = [player2 getNewAction];
  [player1 setPayoff: [player1 getPayoff] + matrix[action1][action2]];
  [player2 setPayoff: [player2 getPayoff] + matrix[action2][action1]];
  return self;
}

-(id)getWinner {
  id winner;
  if ([player1 getPayoff] > [player2 getPayoff])
    winner = player1;
  else
    winner = player2;
  return winner;
}

-(id)getLoser {
  id loser;
  if ([player1 getPayoff] < [player2 getPayoff])
    loser = player1;
  else
    loser = player2;
  return loser;
}

-run {
  int time;
  
  numIter = 4; 
  for (time=0; time<numIter; time++) {
    [self updateMemories];
    [player1 step: time];
    [player2 step: time];
    [self distrPayoffs];
  }
  return self;
}

@end



  


